// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.Helpers.AjaxHelper");

com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getFile = function(fileName) {
    if(!top.fileExists(fileName)){
        return null;
    }
    var xmlDoc = null;
    if (window.ActiveXObject) { // code for IE
        xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
    } else {
        if (document.implementation.createDocument) { // code for Mozilla, Firefox, Opera, etc.
            xmlDoc = document.implementation.createDocument("", "", null);
        }
        else {
            alert('Your browser cannot handle this script');
        }
    }
    if (xmlDoc != null) {
        xmlDoc.async = false;
		if(top.isWindows())
		{
			xmlDoc.load(fileName);
		}
		else
		{
			try{
			var oParser=new DOMParser();
			xmlDoc=oParser.parseFromString(this.getTextFile(fileName),"text/xml");
			}
			catch(e)
			{	//FF17- has exception. use same code with Win
				xmlDoc.load(fileName);
			}
		}
		return xmlDoc;
     
    }
};

com.ibm.bpm.QuickStart.Helpers.AjaxHelper.getTextFile = function(fileName){
	if(top.isWindows())
	{
    var returnValue = {
      value: null,
      complete: false,
      setValue: function(value){
        returnValue.value=value;
    returnValue.complete=true;
      }
    };

    var xhrArgs = {
    url: fileName,
    handleAs: "text",
    sync:true,
    load: dojo.hitch(returnValue, "setValue"),
    error: function(error){
    }
  };
    var deferred = dojo.xhrGet(xhrArgs);
    
    while(returnValue.complete == false) {};
    return returnValue.value;

	}
	else
	{
		try{
	    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(fileName);
        if (file.exists() == false) { return null; }
        var input = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        input.init(file, 0x01, 00004, null);
        var scripInput = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        scripInput.init(input);
        var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";
        var output = converter.ConvertToUnicode(scripInput.read(scripInput.available()));
	    return output;
	  }
	  catch(e)
	  {
	  	//FF17- has exception. use same code with Win
	  	var returnValue = {
      	value: null,
      	complete: false,
      	setValue: function(value){
        returnValue.value=value;
    	returnValue.complete=true;
      	}
    	};

    	var xhrArgs = {
    	url: fileName,
    	handleAs: "text",
    	sync:true,
    	load: dojo.hitch(returnValue, "setValue"),
    	error: function(error){
    	}
  		};
    	var deferred = dojo.xhrGet(xhrArgs);
    
    	while(returnValue.complete == false) {};
    	return returnValue.value;

	  }
	}

}
