// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.


dojo.provide("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");
dojo.require("com.ibm.bpm.QuickStart.utils.Logger");

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome = function() {
    return getEnv("WAS_HOME")+top.PATHSEPARATOR;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getDeName = function() {
    var deName=null;
    if(top.OSTYPE=="unix"){
        deName = getEnv("deName");
    } else {
        deName = getEnv("-deName");
    }
    // top.logError("DEName="+deName);
    if(deName.search("profileName")!=-1){
        return "";
    } else {
        return deName;
    }
};  

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName = function() {
    var profileName=null;
    if(top.OSTYPE=="unix"){
        profileName = getEnv("profileName");
    } else {
        profileName = getEnv("-profileName");
    }
    if(profileName.search("userName")!=-1){
        return "";
    } else {
        return profileName;
    }
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getUserName = function() {
    var userName=null;
    if(top.OSTYPE=="unix"){
        userName = getEnv("userName");
    } else {
        userName = getEnv("-userName");
    }
    if(userName.search("password")!=-1){
        return "";
    } else {
        return userName;
    }
};  

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPassword = function() {
    if(top.OSTYPE=="unix"){
        return getEnv("password");
    } else {
        return getEnv("-password");
    }
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getLaunchPadContentDirectory = function(){
	var dir = this.getBPMHome()+"BPM"+top.PATHSEPARATOR+"QuickStart"+top.PATHSEPARATOR+"launchpad"+top.PATHSEPARATOR+"content"+top.PATHSEPARATOR;
    return dir;
    //return top.STARTINGDIR+"launchpad"+top.PATHSEPARATOR+"content"+top.PATHSEPARATOR;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.runJava = function(launchpadConentDirectory,jarFileName,methodName,parameters,logFileName){
    if(launchpadConentDirectory==null || jarFileName==null || parameters==null || logFileName==null ){
        return null;
     }
     // top.logError("launchpadConentDirectory = "+launchpadConentDirectory);

     if(top.isWindows())
     {
     	runProgram(null,command("runJava",launchpadConentDirectory+top.PATHSEPARATOR+"lib"+top.PATHSEPARATOR+jarFileName,methodName,parameters,logFileName),FOREGROUND, HIDDEN);
     }
     else
     {
     	runProgram(null,command("runJava",launchpadConentDirectory,jarFileName,methodName,parameters,logFileName),FOREGROUND, HIDDEN);
     }
     var responseText = top.readTextFile(logFileName, "ASCII");
        
     if (null == responseText) {
           // message = "E: runJavaMethod returned null while fetching Launchpad updates";
//            logger.logMessage(message);
            return null;
     }
	if(""==responseText)
	{
		return responseText;
	}
     var response = eval("(" + responseText + ")");
     return response;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.startDE = function(BPMHome,profileName,deName,logFileName){
    if(BPMHome==null || profileName ==null ||deName ==null ||logFileName==null){
        return null;
    }

    try 
    {
    	if(top.isWindows())
    	{
    		runProgram(null,command("runStartDE",BPMHome,profileName,deName,logFileName),FOREGROUND,VISIBLE);
    	}
    	else
    	{
    		runProgram(null,command("runStartDE",BPMHome,profileName,deName,logFileName),BACKGROUND ,VISIBLE);
    	}
    } catch (exception){
alert(exception);
        top.logError(exception);
        return false;    
    }
    return true;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.stopDE = function(BPMHome,profileName,deName,userName,password,logFileName,callback){
    if(BPMHome==null || profileName ==null ||deName ==null ||userName == null || password == null ||logFileName==null){
        return null;
    }
    try 
    {
    	if(top.isWindows())
    	{
    		runProgram(null,command("runStopDE",BPMHome,profileName,deName,userName,password,logFileName),FOREGROUND,VISIBLE);
    	}
    	else
    	{
    		//runProgram(null,command("runStopDE",BPMHome,profileName,deName,userName,password,logFileName),BACKGROUND ,VISIBLE);
			runProgram(null,command("runStopDE",BPMHome,profileName,deName,userName,password,logFileName),BACKGROUND ,VISIBLE,null,null,function(rc){
			callback.showQuickStartLinks();
			});
    	}
    } catch (exception){
alert(exception);
        return false;    
    }
    return true;
};

//tangshujun, add for profilePath
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfilePath = function(BPMHome,profileName,logFileName){

    var result= "";
    var responseText="";
    if(BPMHome==null ||profileName ==null ){
        return "";
    }
    else if (logFileName==null){
      logFileName=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getLaunchPadContentDirectory()+profileName;
     // alert("logFileName in profilePath: "+logFileName);
    }
    
     if(top.isWindows())
     {
     if (!top.fileExists(logFileName)) {
	    runProgram(null,command("getProfilePath",BPMHome,profileName,logFileName),FOREGROUND,HIDDEN);
      //runProgram(null,command("getProfilePath",BPMHome,profileName,logFileName),FOREGROUND,VISIBLE);
	 }     
      responseText = top.readTextFile(logFileName, "UTF-8");
            if (null == responseText) {
                 // message = "E: runJavaMethod returned null while fetching Launchpad updates";
                  // logger.logMessage(message);
                result=null;
             }
   	    if(""==responseText){
		         result="";
       	   }
     }
     else
     {
       if (!top.fileExists(logFileName)) {
     	  //runProgram(null,command("runJava",launchpadConentDirectory,jarFileName,methodName,parameters,logFileName),FOREGROUND, HIDDEN);
           runProgram(null,command("getProfilePath",BPMHome,profileName,logFileName),FOREGROUND,VISIBLE);
        }
        responseText = top.readTextFile(logFileName, "UTF-8");
            if (null == responseText) {
                 // message = "E: runJavaMethod returned null while fetching Launchpad updates";
                  // logger.logMessage(message);
                result=null;
             }
   	    if(""==responseText){
		         result="";
       	   }               
     }
     responseText  = responseText.replace('\n', '');
     responseText  = responseText.replace('\r', '');
     result=  responseText;
     return result;
};

//guyujie
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getDeState = function(BPMHome,profileName,deName,logFileName,callback){

    var result= -1;
    if(BPMHome==null ||profileName ==null ||deName ==null ||logFileName==null){
        return -1;
    }
    try 
    {
    	if(top.isWindows()) {
    		runProgram(null,command("getDeState",BPMHome,profileName,deName,logFileName),FOREGROUND,HIDDEN,null,null,function(rc){
    		
    		//use VISIBLE for debug
    		//runProgram(null,command("getDeState",BPMHome,profileName,deName,logFileName),FOREGROUND,VISIBLE,null,null,function(rc){
			result=rc;
		    });
			   
	    } else {

			result=runProgram(null,command("getDeState",BPMHome,profileName,deName,logFileName),FOREGROUND,VISIBLE,null,null,function(rc){
			//result=rc;
			return rc;
			//callback.showQuickStartLinks();
			});
		}
    } catch (exception){
		alert(exception.message);
        	return -1;    
    }
    return result;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.listSubDirectories = function(directory){
     var now = new Date().getTime();
     var logFileName = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempFilename("listDirectories_"+now);
     runProgram(null,command("listDirectories",directory,logFileName),FOREGROUND, HIDDEN);
     var responseText = top.readTextFile(logFileName+".json", "ASCII");
        
     if (null == responseText) {
            return null;
     }
     var response = eval("(" + responseText + ")");
     //clean the /tmp folder
     var filePath=logFileName+".json";
	 runProgram(null,command("deleteFile",filePath),FOREGROUND, HIDDEN);
     return response.folders;
};
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.isValidDoneFile = function(file){
   // logger.logMessage("I: start of isValidDoneFile method");
    
        var exits = top.fileExists(file + ".done");
        var doneFile;
        var doneStatus;
        var valid  = false;
        if(exits){
            doneFile = top.readTextFile(file + ".done", "ASCII");
            doneStatus = dojo.fromJson(doneFile);
            
            if(doneStatus.isSuccess){
                valid = true;
                return valid;
            }
        }
    
    //logger.logMessage("I: End of isValidDoneFile method with return Value"+valid);  
        
    return valid;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempDirectory = function(){
    if (top.tempDir == null || !top.tempDir) {
        var now = new Date().getTime();
        tempDir = top.getNativeFileName(getEnv("LaunchPadTemp") + "/../IBM_BPM_QuickStart");

        // Create the new temp dir
		if(!top.fileExists(tempDir))
        com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.createDir(tempDir);
            
        top.tempDir = tempDir;
    }
    return top.tempDir;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempFilename = function(filename) {
    return top.getNativeFileName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempDirectory() + "/" + filename);
};
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.directoryExists = function(directory){
    return top.directoryExists(NO_DISKID,directory);
}

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.createDir = function(dirNativeName) {
    if (top.isWindows()) {
        top.createDirectory(dirNativeName);
    } else {
        top.runProgram(null, top.command("createDir", dirNativeName), FOREGROUND, HIDDEN);
    }
};

// format the time stamp like 20140114-180019
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getFormatTimeStamp = function(){
	var now = new Date();
	var time_stamp;
	time_stamp = now.getFullYear();
	if((now.getMonth()+1)<10)
	{
		time_stamp=time_stamp+"0";
	}
	time_stamp += (now.getMonth()+1);
	if(now.getDate()<10)
	{
		time_stamp=time_stamp+"0";
	}
	time_stamp +=now.getDate()+"-";
	if(now.getHours()<10)
	{
		time_stamp=time_stamp+"0";
	}
	time_stamp +=now.getHours();
	if(now.getMinutes()<10)
	{
		time_stamp=time_stamp+"0";
	}
	time_stamp +=now.getMinutes();
	if(now.getSeconds()<10)
	{
		time_stamp=time_stamp+"0";
	}
	time_stamp +=now.getSeconds();
	
	return time_stamp;

};
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger = function(){
	var timeStamp = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getFormatTimeStamp();
    if ( top.tempLogFile == null || ! top.tempLogFile ){
        top.tempLogFile = com.ibm.bpm.QuickStart.utils.Logger("BPM_QuickStart"+timeStamp+".log");
     }
     
     return top.tempLogFile;
};
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getFileListing = function(directory, prefix, suffix){
	var prefixLen = (prefix != null) ? prefix.length : 0;
	var suffixLen = (suffix != null) ? suffix.length : 0;	
	var func = new Function('return window');
	var files = top.secureGetFiles(func, directory);
	if(files != null && (prefixLen > 0 || suffixLen > 0)) {
		var filesLen = files.length
		var filterFiles=new Array();
		for(var i=0;i<filesLen;i++) {
			var fileNm = files[i];
			if(prefixLen>0 && suffixLen>0) { 
			  if(fileNm.slice(0,prefixLen)==prefix && fileNm.slice(-suffixLen)==suffix) {
				filterFiles[filterFiles.length] = fileNm;
			  }
			}
			else if(prefixLen>0) { 
			  if(fileNm.slice(0,prefixLen)==prefix) {
				filterFiles[filterFiles.length] = fileNm;
			  }
			}
			else if(suffixLen>0) { 
			  if(fileNm.slice(-suffixLen)==suffix) {
				filterFiles[filterFiles.length] = fileNm;
			  }
			}			
		}
		return filterFiles;
	}
	return files;
};
com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getLatestConfigLogFile = function() {
	var bpmHomeDir = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome();
	var configLogFile = null;
	var configLogDir = bpmHomeDir+"logs"+top.PATHSEPARATOR+"config"+top.PATHSEPARATOR;
	var files = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getFileListing(configLogDir,"BPMConfig_",".log");
	var lastModifyTime = null;
	var lastConfigLogFile = null;
	for(var i=0;i<files.length;i++){
			if(files != null && files.length > 0) {
			//configLogFile = (configLogDir+files[files.length-1]);
			configLogFile = configLogDir+files[i];		
			var modifyTime = this.getFileModifyTime(configLogFile);
			
			//alert(configLogFile +"------------"+ modifyTime)
			if(lastModifyTime==null || lastModifyTime<modifyTime){
				lastModifyTime=modifyTime;
				lastConfigLogFile = configLogFile;
				//alert(lastConfigLogFile)
			}
		}
		
	}
	return lastConfigLogFile;
};

com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getFileModifyTime = function(filepath) 
{
	if(top.isWindows())
	{
		var sfso = new ActiveXObject("Scripting.FileSystemObject");
		var  file= sfso.GetFile(filepath);
		return file.DateCreated;
	}
	else
	{ 
		try
		{
			//for FF 17-
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		}
		catch(e){}
		
		var file = Components.classes["@mozilla.org/file/local;1"] .createInstance(Components.interfaces.nsILocalFile);  
		file.initWithPath(filepath); 
		return file. lastModifiedTime;
	}
	return configLogFile;
};
