// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.utils.Logger");
dojo.require("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");

dojo.declare("com.ibm.bpm.QuickStart.utils.Logger", null, {
    logFile: null,
    
    constructor: function(fileName){
        if(fileName!=null){
            this.logFile = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempFilename(fileName);
        } else {
            //throw error
        }
    },
    
    getLogFile: function(){
        return this.logFile;
    },

    logMessage: function(message){
        var now = new Date();
		var time_stamp;
		// get the formate time, eg: �2013-10-18 18:29:15
		time_stamp = (now.getFullYear())+"-";
		if((now.getMonth()+1)<10)
		{
			time_stamp=time_stamp+"0";
		}
		time_stamp += (now.getMonth()+1)+"-";
		if(now.getDate()<10)
		{
			time_stamp=time_stamp+"0";
		}
		time_stamp +=now.getDate()+" ";
		if(now.getHours()<10)
		{
			time_stamp=time_stamp+"0";
		}
		time_stamp +=now.getHours()+":";
		if(now.getMinutes()<10)
		{
			time_stamp=time_stamp+"0";
		}
		time_stamp +=now.getMinutes()+":";
		if(now.getSeconds()<10)
		{
			time_stamp=time_stamp+"0";
		}
		time_stamp +=now.getSeconds();
        message = "" + time_stamp + " " + message;
        
        if (top.isWindows()) {
            message += "\r\n";
        }
        else {
            message += "\n";
        }
        top.writeTextFile(this.getLogFile(), message, true, "UTF-8");
    },
    
    entering: function(clazz,method,message){
        this.logMessage(clazz+"->"+ method + ": " + message);
    },
    exiting: function(clazz,method,message){
        this.logMessage(clazz+"->"+ method + ": " + message);
    }
    
});
